
#include "C:\Users\Chris\source\repos\PNG\lodepng.h"
#include "C:\Users\Chris\source\repos\PNG\lodepng.cpp"
#include <fstream>
#include <sstream>
#include <string>
#include <atlstr.h>
#include <iterator>
#include <iostream>
#include <bitset>
using namespace std;

//Encode from raw pixels to disk with a single function call
//The image argument has width * height RGBA pixels or width * height * 4 bytes
void encodeOneStep(const char* filename, std::vector<unsigned char>& image, unsigned width, unsigned height) {
    //Encode the image
    unsigned error = lodepng::encode(filename, image, width, height);

    //if there's an error, display it
    if (error) std::cout << "encoder error " << error << ": " << lodepng_error_text(error) << std::endl;
}


int main()
{
    const unsigned width = 16, height = 16, no_elems = 14088; // no_elems is the size of the png image array.
    std::vector<unsigned char> image(no_elems);

    CString File_Path;
    char sztmp[1024];
    const char* filepath = " ";


    cin.clear();
    cout << "Enter Path to extract sprite graphics to: " << endl;
    cin.getline(sztmp, sizeof(sztmp), '\n');
    filepath = sztmp;


    //  Pallette Kong Letters and Banana Sprites
    static const unsigned char colours[16][4] = { // An array of colour values
        //BBB  GGG  RRR AAA
        { 255, 255, 255,255 }, /* White    */
        {   64,  48,  0, 255 }, /* Index  1 */ 
        {   112,  72, 0, 255 }, /* Index  2 */ 
        {  168, 104, 56, 255 }, /* Index  3 */ 
        {   216, 152, 0, 255 }, /* Index  4 */ 
        {   248, 216, 8, 255 }, /* Index  5 */  
        { 255, 255, 255, 255 }, /* Index  6 */ 
        { 208, 208, 208, 255 }, /* Index  7 */
        { 160, 160, 160, 255 }, /* Index  8 */
        { 112, 120, 120, 255 }, /* Index  9 */
        {  72,   0,  0, 255 }, /* Index 10 */ 
        {   160,   8, 8, 255 }, /* Index 11 */ 
        {  248,  16, 16, 255 }, /* Index 12 */ 
        {  248, 104, 8, 255 }, /* Index 13 */ 
        {   0, 248,   0, 255 }, /* Index 14 */
        {   0,   0,   0, 255 }  /* Index 15 */
    };

    // Donkey Kong Pallette
    static const unsigned char coloursB[16][4] = { // An array of colour values. 
       //RRR  GGG  BBB  AAA
       { 255, 255, 255, 255 }, /* White    */ 
       {   33,  16,  8, 255 }, /* Index  1 */ 
       {   255,  132, 115, 255 }, /* Index  2 */
       {  255, 198, 189, 255 }, /* Index  3 */ 
       {   140, 66, 0, 255 }, /* Index  4 */ 
       {   198, 99, 0, 255 }, /* Index  5 */
       { 82, 33, 16, 255 }, /* Index  6 */
       { 132, 57, 24, 255 }, /* Index  7 */
       { 181, 82, 33, 255 }, /* Index  8 */ 
       { 148, 82, 57, 255 }, /* Index  9 */ 
       {  206,   132,  99, 255 }, /* Index 10 */ 
       {   255,   181, 140, 255 }, /* Index 11 */ 
       {  173,  16, 8, 255 }, /* Index 12 */ 
       {   255, 49, 33, 255 }, /* Index 13 */
       {  123, 123,   123, 255 }, /* Index 14 */
       {   255, 255,  255, 255 }  /* Index 15 */
    };

    // Diddy Kong Pallette
    static const unsigned char coloursC[16][4] = { // An array of colour values.   // Needs correcting
       //RRR  GGG  BBB  AAA
       { 255, 255, 255, 255 }, /* White    */ ///////////////////////////////////////////////////////
       {   48,  24,  8, 255 }, /* Index  1 */ ///////////////////////////////////////////////////////
       {   80,  32, 16, 255 }, /* Index  2 */ ///////////////////////////////////////////////////////
       {  104, 48, 24, 255 }, /* Index  3 */ ///////////////////////////////////////////////////////
       {   144, 64, 24, 255 }, /* Index  4 */ //////////////////////////////////////////////////////
       {   176, 80, 32, 255 }, /* Index  5 */ /////////////////////////////////////////////////////
       { 144, 80, 56, 255 }, /* Index  6 */ ///////////////////////////////////////////////////////
       { 200, 112, 88, 255 }, /* Index  7 */ /////////////////////////////////////////////////////
       { 248, 152, 112, 255 }, /* Index  8 */ ////////////////////////////////////////////////////
       { 248, 176, 136, 255 }, /* Index  9 */ ///////////////////////////////////////////////////
       {  248,   208,  152, 255 }, /* Index 10 */ ///////////////////////////////////////////////
       {   168,   16, 8, 255 }, /* Index 11 */ //////////////////////////////////////////////////
       {  208,  24, 16, 255 }, /* Index 12 */ //////////////////////////////////////////////////
       {   248, 48, 32, 255 }, /* Index 13 */ ////////////////////////////////////////////////
       {  120, 120,   120, 255 }, /* Index 14 */ /////////////////////////////////////////////
       {   248,   248,   248, 255 }  /* Index 15 */ //////////////////////////////////////////
    };

    char oData[0x6000]; // The Array for the Kong letters
    ifstream inFile;
    inFile.open("C:\\Users\\Chris\\Desktop\\DK\\Emulators ad Debuggers\\zsnesw150\\dkc1.sfc", ios::binary); // Note. this opens a binary streem. This is needed. cuzz the program was using 0x1a values as a Sustitute AscII charter which halts the program/Using it as End Of File.
    inFile.seekg(0x347519 + 10, 1);
    inFile.read(oData, 0x6000);
    inFile.close();

    char oDataB[0x6000]; // The Array for the Bananas
    ifstream inFileB;
    inFileB.open("C:\\Users\\Chris\\Desktop\\DK\\Emulators ad Debuggers\\zsnesw150\\dkc1.sfc", ios::binary); // Note. this opens a binary streem. This is needed. cuzz the program was using 0x1a values as a Sustitute AscII charter which halts the program/Using it as End Of File.
    inFileB.seekg(0xEF88E + 10, 1);
    inFileB.read(oDataB, 0x6000);
    inFileB.close();
    
    char oDataC[0x6000]; // The Array for DK Map? Sprites
    ifstream inFileC;
    inFileC.open("C:\\Users\\Chris\\Desktop\\DK\\Emulators ad Debuggers\\zsnesw150\\dkc1.sfc", ios::binary); // Note. this opens a binary streem. This is needed. cuzz the program was using 0x1a values as a Sustitute AscII charter which halts the program/Using it as End Of File.
    inFileC.seekg(0x19FA3A + 10, 1);
    inFileC.read(oDataC, 0x6000);
    inFileC.close();

    char oDataD[0x6000]; // The Array for Diddy Map? Sprites
    ifstream inFileD;
    inFileD.open("C:\\Users\\Chris\\Desktop\\DK\\Emulators ad Debuggers\\zsnesw150\\dkc1.sfc", ios::binary); // Note. this opens a binary streem. This is needed. cuzz the program was using 0x1a values as a Sustitute AscII charter which halts the program/Using it as End Of File.
    inFileD.seekg(0x240000 + 10, 1);
    inFileD.read(oDataD, 0x6000);
    inFileD.close();

    int E = 0; // The location of the current sprite whithin the buffer. 
    int offset = 0; // The location of the next set of sprites.

    // Create the Bitplanes
    int* Bitplane0_Top_Left_ROW = new int[8];
    int* Bitplane1_Top_Left_ROW = new int[8];
    int* Bitplane2_Top_Left_ROW = new int[8];
    int* Bitplane3_Top_Left_ROW = new int[8];

    int* Bitplane0_Top_Right_ROW = new int[8];
    int* Bitplane1_Top_Right_ROW = new int[8];
    int* Bitplane2_Top_Right_ROW = new int[8];
    int* Bitplane3_Top_Right_ROW = new int[8];

    int* Bitplane0_Bottom_Left_ROW = new int[8];
    int* Bitplane1_Bottom_Left_ROW = new int[8];
    int* Bitplane2_Bottom_Left_ROW = new int[8];
    int* Bitplane3_Bottom_Left_ROW = new int[8];

    int* Bitplane0_Bottom_Right_ROW = new int[8];
    int* Bitplane1_Bottom_Right_ROW = new int[8];
    int* Bitplane2_Bottom_Right_ROW = new int[8];
    int* Bitplane3_Bottom_Right_ROW = new int[8];


    // Assign each Bitplane Row the data from the buffer. oData is the buffer containing the bytes from the rom.
    for (int X = 0; X <= 80; X++)

    {   
        if (X <= 25) // Assign the Kong Letters to the bitplane rows.
        {
            // Top Left Tile
            Bitplane0_Top_Left_ROW[0] = oData[14 + E + offset];
            Bitplane0_Top_Left_ROW[1] = oData[12 + E + offset];
            Bitplane0_Top_Left_ROW[2] = oData[10 + E + offset];
            Bitplane0_Top_Left_ROW[3] = oData[8 + E + offset];
            Bitplane0_Top_Left_ROW[4] = oData[6 + E + offset];
            Bitplane0_Top_Left_ROW[5] = oData[4 + E + offset];
            Bitplane0_Top_Left_ROW[6] = oData[2 + E + offset];
            Bitplane0_Top_Left_ROW[7] = oData[0 + E + offset];

            Bitplane1_Top_Left_ROW[0] = oData[15 + E + offset];
            Bitplane1_Top_Left_ROW[1] = oData[13 + E + offset];
            Bitplane1_Top_Left_ROW[2] = oData[11 + E + offset];
            Bitplane1_Top_Left_ROW[3] = oData[9 + E + offset];
            Bitplane1_Top_Left_ROW[4] = oData[7 + E + offset];
            Bitplane1_Top_Left_ROW[5] = oData[5 + E + offset];
            Bitplane1_Top_Left_ROW[6] = oData[3 + E + offset];
            Bitplane1_Top_Left_ROW[7] = oData[1 + E + offset];

            Bitplane2_Top_Left_ROW[0] = oData[30 + E + offset];
            Bitplane2_Top_Left_ROW[1] = oData[28 + E + offset];
            Bitplane2_Top_Left_ROW[2] = oData[26 + E + offset];
            Bitplane2_Top_Left_ROW[3] = oData[24 + E + offset];
            Bitplane2_Top_Left_ROW[4] = oData[22 + E + offset];
            Bitplane2_Top_Left_ROW[5] = oData[20 + E + offset];
            Bitplane2_Top_Left_ROW[6] = oData[18 + E + offset];
            Bitplane2_Top_Left_ROW[7] = oData[16 + E + offset];

            Bitplane3_Top_Left_ROW[0] = oData[31 + E + offset];
            Bitplane3_Top_Left_ROW[1] = oData[29 + E + offset];
            Bitplane3_Top_Left_ROW[2] = oData[27 + E + offset];
            Bitplane3_Top_Left_ROW[3] = oData[25 + E + offset];
            Bitplane3_Top_Left_ROW[4] = oData[23 + E + offset];
            Bitplane3_Top_Left_ROW[5] = oData[21 + E + offset];
            Bitplane3_Top_Left_ROW[6] = oData[19 + E + offset];
            Bitplane3_Top_Left_ROW[7] = oData[17 + E + offset];

            // Top Right Tile


            Bitplane0_Top_Right_ROW[0] = oData[46 + E + offset];
            Bitplane0_Top_Right_ROW[1] = oData[44 + E + offset];
            Bitplane0_Top_Right_ROW[2] = oData[42 + E + offset];
            Bitplane0_Top_Right_ROW[3] = oData[40 + E + offset];
            Bitplane0_Top_Right_ROW[4] = oData[38 + E + offset];
            Bitplane0_Top_Right_ROW[5] = oData[36 + E + offset];
            Bitplane0_Top_Right_ROW[6] = oData[34 + E + offset];
            Bitplane0_Top_Right_ROW[7] = oData[32 + E + offset];

            Bitplane1_Top_Right_ROW[0] = oData[47 + E + offset];
            Bitplane1_Top_Right_ROW[1] = oData[45 + E + offset];
            Bitplane1_Top_Right_ROW[2] = oData[43 + E + offset];
            Bitplane1_Top_Right_ROW[3] = oData[41 + E + offset];
            Bitplane1_Top_Right_ROW[4] = oData[39 + E + offset];
            Bitplane1_Top_Right_ROW[5] = oData[37 + E + offset];
            Bitplane1_Top_Right_ROW[6] = oData[35 + E + offset];
            Bitplane1_Top_Right_ROW[7] = oData[33 + E + offset];

            Bitplane2_Top_Right_ROW[0] = oData[62 + E + offset];
            Bitplane2_Top_Right_ROW[1] = oData[60 + E + offset];
            Bitplane2_Top_Right_ROW[2] = oData[58 + E + offset];
            Bitplane2_Top_Right_ROW[3] = oData[56 + E + offset];
            Bitplane2_Top_Right_ROW[4] = oData[54 + E + offset];
            Bitplane2_Top_Right_ROW[5] = oData[52 + E + offset];
            Bitplane2_Top_Right_ROW[6] = oData[50 + E + offset];
            Bitplane2_Top_Right_ROW[7] = oData[48 + E + offset];

            Bitplane3_Top_Right_ROW[0] = oData[63 + E + offset];
            Bitplane3_Top_Right_ROW[1] = oData[61 + E + offset];
            Bitplane3_Top_Right_ROW[2] = oData[59 + E + offset];
            Bitplane3_Top_Right_ROW[3] = oData[57 + E + offset];
            Bitplane3_Top_Right_ROW[4] = oData[55 + E + offset];
            Bitplane3_Top_Right_ROW[5] = oData[53 + E + offset];
            Bitplane3_Top_Right_ROW[6] = oData[51 + E + offset];
            Bitplane3_Top_Right_ROW[7] = oData[49 + E + offset];


            //  Bottom Left Tile


            Bitplane0_Bottom_Left_ROW[0] = oData[78 + E + offset];
            Bitplane0_Bottom_Left_ROW[1] = oData[76 + E + offset];
            Bitplane0_Bottom_Left_ROW[2] = oData[74 + E + offset];
            Bitplane0_Bottom_Left_ROW[3] = oData[72 + E + offset];
            Bitplane0_Bottom_Left_ROW[4] = oData[70 + E + offset];
            Bitplane0_Bottom_Left_ROW[5] = oData[68 + E + offset];
            Bitplane0_Bottom_Left_ROW[6] = oData[66 + E + offset];
            Bitplane0_Bottom_Left_ROW[7] = oData[64 + E + offset];

            Bitplane1_Bottom_Left_ROW[0] = oData[79 + E + offset];
            Bitplane1_Bottom_Left_ROW[1] = oData[77 + E + offset];
            Bitplane1_Bottom_Left_ROW[2] = oData[75 + E + offset];
            Bitplane1_Bottom_Left_ROW[3] = oData[73 + E + offset];
            Bitplane1_Bottom_Left_ROW[4] = oData[71 + E + offset];
            Bitplane1_Bottom_Left_ROW[5] = oData[69 + E + offset];
            Bitplane1_Bottom_Left_ROW[6] = oData[67 + E + offset];
            Bitplane1_Bottom_Left_ROW[7] = oData[65 + E + offset];

            Bitplane2_Bottom_Left_ROW[0] = oData[94 + E + offset];
            Bitplane2_Bottom_Left_ROW[1] = oData[92 + E + offset];
            Bitplane2_Bottom_Left_ROW[2] = oData[90 + E + offset];
            Bitplane2_Bottom_Left_ROW[3] = oData[88 + E + offset];
            Bitplane2_Bottom_Left_ROW[4] = oData[86 + E + offset];
            Bitplane2_Bottom_Left_ROW[5] = oData[84 + E + offset];
            Bitplane2_Bottom_Left_ROW[6] = oData[82 + E + offset];
            Bitplane2_Bottom_Left_ROW[7] = oData[80 + E + offset];

            Bitplane3_Bottom_Left_ROW[0] = oData[95 + E + offset];
            Bitplane3_Bottom_Left_ROW[1] = oData[93 + E + offset];
            Bitplane3_Bottom_Left_ROW[2] = oData[91 + E + offset];
            Bitplane3_Bottom_Left_ROW[3] = oData[89 + E + offset];
            Bitplane3_Bottom_Left_ROW[4] = oData[87 + E + offset];
            Bitplane3_Bottom_Left_ROW[5] = oData[85 + E + offset];
            Bitplane3_Bottom_Left_ROW[6] = oData[83 + E + offset];
            Bitplane3_Bottom_Left_ROW[7] = oData[81 + E + offset];


            //  Bottom Right Tile


            Bitplane0_Bottom_Right_ROW[0] = oData[110 + E + offset];
            Bitplane0_Bottom_Right_ROW[1] = oData[108 + E + offset];
            Bitplane0_Bottom_Right_ROW[2] = oData[106 + E + offset];
            Bitplane0_Bottom_Right_ROW[3] = oData[104 + E + offset];
            Bitplane0_Bottom_Right_ROW[4] = oData[102 + E + offset];
            Bitplane0_Bottom_Right_ROW[5] = oData[100 + E + offset];
            Bitplane0_Bottom_Right_ROW[6] = oData[98 + E + offset];
            Bitplane0_Bottom_Right_ROW[7] = oData[96 + E + offset];

            Bitplane1_Bottom_Right_ROW[0] = oData[111 + E + offset];
            Bitplane1_Bottom_Right_ROW[1] = oData[109 + E + offset];
            Bitplane1_Bottom_Right_ROW[2] = oData[107 + E + offset];
            Bitplane1_Bottom_Right_ROW[3] = oData[105 + E + offset];
            Bitplane1_Bottom_Right_ROW[4] = oData[103 + E + offset];
            Bitplane1_Bottom_Right_ROW[5] = oData[101 + E + offset];
            Bitplane1_Bottom_Right_ROW[6] = oData[99 + E + offset];
            Bitplane1_Bottom_Right_ROW[7] = oData[97 + E + offset];


            Bitplane2_Bottom_Right_ROW[0] = oData[126 + E + offset];
            Bitplane2_Bottom_Right_ROW[1] = oData[124 + E + offset];
            Bitplane2_Bottom_Right_ROW[2] = oData[122 + E + offset];
            Bitplane2_Bottom_Right_ROW[3] = oData[120 + E + offset];
            Bitplane2_Bottom_Right_ROW[4] = oData[118 + E + offset];
            Bitplane2_Bottom_Right_ROW[5] = oData[116 + E + offset];
            Bitplane2_Bottom_Right_ROW[6] = oData[114 + E + offset];
            Bitplane2_Bottom_Right_ROW[7] = oData[112 + E + offset];


            Bitplane3_Bottom_Right_ROW[0] = oData[127 + E + offset];
            Bitplane3_Bottom_Right_ROW[1] = oData[125 + E + offset];
            Bitplane3_Bottom_Right_ROW[2] = oData[123 + E + offset];
            Bitplane3_Bottom_Right_ROW[3] = oData[121 + E + offset];
            Bitplane3_Bottom_Right_ROW[4] = oData[119 + E + offset];
            Bitplane3_Bottom_Right_ROW[5] = oData[117 + E + offset];
            Bitplane3_Bottom_Right_ROW[6] = oData[115 + E + offset];
            Bitplane3_Bottom_Right_ROW[7] = oData[113 + E + offset];

            E = E + 128 + 10; // the location of the curent sprite. Each sprite is 128 bytes (32 bytes x  4 tiles). The +10 is the size of the header.
        }


        if (X > 26 && X <=34) // Assign the Banana Sprites to the bitplane rows.
        {
            if (X == 27) { E = 0; }

            // Top Left Tile
            Bitplane0_Top_Left_ROW[0] = oDataB[14 + E + offset];
            Bitplane0_Top_Left_ROW[1] = oDataB[12 + E + offset];
            Bitplane0_Top_Left_ROW[2] = oDataB[10 + E + offset];
            Bitplane0_Top_Left_ROW[3] = oDataB[8 + E + offset];
            Bitplane0_Top_Left_ROW[4] = oDataB[6 + E + offset];
            Bitplane0_Top_Left_ROW[5] = oDataB[4 + E + offset];
            Bitplane0_Top_Left_ROW[6] = oDataB[2 + E + offset];
            Bitplane0_Top_Left_ROW[7] = oDataB[0 + E + offset];

            Bitplane1_Top_Left_ROW[0] = oDataB[15 + E + offset];
            Bitplane1_Top_Left_ROW[1] = oDataB[13 + E + offset];
            Bitplane1_Top_Left_ROW[2] = oDataB[11 + E + offset];
            Bitplane1_Top_Left_ROW[3] = oDataB[9 + E + offset];
            Bitplane1_Top_Left_ROW[4] = oDataB[7 + E + offset];
            Bitplane1_Top_Left_ROW[5] = oDataB[5 + E + offset];
            Bitplane1_Top_Left_ROW[6] = oDataB[3 + E + offset];
            Bitplane1_Top_Left_ROW[7] = oDataB[1 + E + offset];

            Bitplane2_Top_Left_ROW[0] = oDataB[30 + E + offset];
            Bitplane2_Top_Left_ROW[1] = oDataB[28 + E + offset];
            Bitplane2_Top_Left_ROW[2] = oDataB[26 + E + offset];
            Bitplane2_Top_Left_ROW[3] = oDataB[24 + E + offset];
            Bitplane2_Top_Left_ROW[4] = oDataB[22 + E + offset];
            Bitplane2_Top_Left_ROW[5] = oDataB[20 + E + offset];
            Bitplane2_Top_Left_ROW[6] = oDataB[18 + E + offset];
            Bitplane2_Top_Left_ROW[7] = oDataB[16 + E + offset];

            Bitplane3_Top_Left_ROW[0] = oDataB[31 + E + offset];
            Bitplane3_Top_Left_ROW[1] = oDataB[29 + E + offset];
            Bitplane3_Top_Left_ROW[2] = oDataB[27 + E + offset];
            Bitplane3_Top_Left_ROW[3] = oDataB[25 + E + offset];
            Bitplane3_Top_Left_ROW[4] = oDataB[23 + E + offset];
            Bitplane3_Top_Left_ROW[5] = oDataB[21 + E + offset];
            Bitplane3_Top_Left_ROW[6] = oDataB[19 + E + offset];
            Bitplane3_Top_Left_ROW[7] = oDataB[17 + E + offset];

            //  Top Right Tile


            Bitplane0_Top_Right_ROW[0] = oDataB[46 + E + offset];
            Bitplane0_Top_Right_ROW[1] = oDataB[44 + E + offset];
            Bitplane0_Top_Right_ROW[2] = oDataB[42 + E + offset];
            Bitplane0_Top_Right_ROW[3] = oDataB[40 + E + offset];
            Bitplane0_Top_Right_ROW[4] = oDataB[38 + E + offset];
            Bitplane0_Top_Right_ROW[5] = oDataB[36 + E + offset];
            Bitplane0_Top_Right_ROW[6] = oDataB[34 + E + offset];
            Bitplane0_Top_Right_ROW[7] = oDataB[32 + E + offset];

            Bitplane1_Top_Right_ROW[0] = oDataB[47 + E + offset];
            Bitplane1_Top_Right_ROW[1] = oDataB[45 + E + offset];
            Bitplane1_Top_Right_ROW[2] = oDataB[43 + E + offset];
            Bitplane1_Top_Right_ROW[3] = oDataB[41 + E + offset];
            Bitplane1_Top_Right_ROW[4] = oDataB[39 + E + offset];
            Bitplane1_Top_Right_ROW[5] = oDataB[37 + E + offset];
            Bitplane1_Top_Right_ROW[6] = oDataB[35 + E + offset];
            Bitplane1_Top_Right_ROW[7] = oDataB[33 + E + offset];

            Bitplane2_Top_Right_ROW[0] = oDataB[62 + E + offset];
            Bitplane2_Top_Right_ROW[1] = oDataB[60 + E + offset];
            Bitplane2_Top_Right_ROW[2] = oDataB[58 + E + offset];
            Bitplane2_Top_Right_ROW[3] = oDataB[56 + E + offset];
            Bitplane2_Top_Right_ROW[4] = oDataB[54 + E + offset];
            Bitplane2_Top_Right_ROW[5] = oDataB[52 + E + offset];
            Bitplane2_Top_Right_ROW[6] = oDataB[50 + E + offset];
            Bitplane2_Top_Right_ROW[7] = oDataB[48 + E + offset];

            Bitplane3_Top_Right_ROW[0] = oDataB[63 + E + offset];
            Bitplane3_Top_Right_ROW[1] = oDataB[61 + E + offset];
            Bitplane3_Top_Right_ROW[2] = oDataB[59 + E + offset];
            Bitplane3_Top_Right_ROW[3] = oDataB[57 + E + offset];
            Bitplane3_Top_Right_ROW[4] = oDataB[55 + E + offset];
            Bitplane3_Top_Right_ROW[5] = oDataB[53 + E + offset];
            Bitplane3_Top_Right_ROW[6] = oDataB[51 + E + offset];
            Bitplane3_Top_Right_ROW[7] = oDataB[49 + E + offset];


            //  Bottom Left Tile


            Bitplane0_Bottom_Left_ROW[0] = oDataB[78 + E + offset];
            Bitplane0_Bottom_Left_ROW[1] = oDataB[76 + E + offset];
            Bitplane0_Bottom_Left_ROW[2] = oDataB[74 + E + offset];
            Bitplane0_Bottom_Left_ROW[3] = oDataB[72 + E + offset];
            Bitplane0_Bottom_Left_ROW[4] = oDataB[70 + E + offset];
            Bitplane0_Bottom_Left_ROW[5] = oDataB[68 + E + offset];
            Bitplane0_Bottom_Left_ROW[6] = oDataB[66 + E + offset];
            Bitplane0_Bottom_Left_ROW[7] = oDataB[64 + E + offset];

            Bitplane1_Bottom_Left_ROW[0] = oDataB[79 + E + offset];
            Bitplane1_Bottom_Left_ROW[1] = oDataB[77 + E + offset];
            Bitplane1_Bottom_Left_ROW[2] = oDataB[75 + E + offset];
            Bitplane1_Bottom_Left_ROW[3] = oDataB[73 + E + offset];
            Bitplane1_Bottom_Left_ROW[4] = oDataB[71 + E + offset];
            Bitplane1_Bottom_Left_ROW[5] = oDataB[69 + E + offset];
            Bitplane1_Bottom_Left_ROW[6] = oDataB[67 + E + offset];
            Bitplane1_Bottom_Left_ROW[7] = oDataB[65 + E + offset];

            Bitplane2_Bottom_Left_ROW[0] = oDataB[94 + E + offset];
            Bitplane2_Bottom_Left_ROW[1] = oDataB[92 + E + offset];
            Bitplane2_Bottom_Left_ROW[2] = oDataB[90 + E + offset];
            Bitplane2_Bottom_Left_ROW[3] = oDataB[88 + E + offset];
            Bitplane2_Bottom_Left_ROW[4] = oDataB[86 + E + offset];
            Bitplane2_Bottom_Left_ROW[5] = oDataB[84 + E + offset];
            Bitplane2_Bottom_Left_ROW[6] = oDataB[82 + E + offset];
            Bitplane2_Bottom_Left_ROW[7] = oDataB[80 + E + offset];

            Bitplane3_Bottom_Left_ROW[0] = oDataB[95 + E + offset];
            Bitplane3_Bottom_Left_ROW[1] = oDataB[93 + E + offset];
            Bitplane3_Bottom_Left_ROW[2] = oDataB[91 + E + offset];
            Bitplane3_Bottom_Left_ROW[3] = oDataB[89 + E + offset];
            Bitplane3_Bottom_Left_ROW[4] = oDataB[87 + E + offset];
            Bitplane3_Bottom_Left_ROW[5] = oDataB[85 + E + offset];
            Bitplane3_Bottom_Left_ROW[6] = oDataB[83 + E + offset];
            Bitplane3_Bottom_Left_ROW[7] = oDataB[81 + E + offset];


            //  Bottom Right Tile


            Bitplane0_Bottom_Right_ROW[0] = oDataB[110 + E + offset];
            Bitplane0_Bottom_Right_ROW[1] = oDataB[108 + E + offset];
            Bitplane0_Bottom_Right_ROW[2] = oDataB[106 + E + offset];
            Bitplane0_Bottom_Right_ROW[3] = oDataB[104 + E + offset];
            Bitplane0_Bottom_Right_ROW[4] = oDataB[102 + E + offset];
            Bitplane0_Bottom_Right_ROW[5] = oDataB[100 + E + offset];
            Bitplane0_Bottom_Right_ROW[6] = oDataB[98 + E + offset];
            Bitplane0_Bottom_Right_ROW[7] = oDataB[96 + E + offset];

            Bitplane1_Bottom_Right_ROW[0] = oDataB[111 + E + offset];
            Bitplane1_Bottom_Right_ROW[1] = oDataB[109 + E + offset];
            Bitplane1_Bottom_Right_ROW[2] = oDataB[107 + E + offset];
            Bitplane1_Bottom_Right_ROW[3] = oDataB[105 + E + offset];
            Bitplane1_Bottom_Right_ROW[4] = oDataB[103 + E + offset];
            Bitplane1_Bottom_Right_ROW[5] = oDataB[101 + E + offset];
            Bitplane1_Bottom_Right_ROW[6] = oDataB[99 + E + offset];
            Bitplane1_Bottom_Right_ROW[7] = oDataB[97 + E + offset];


            Bitplane2_Bottom_Right_ROW[0] = oDataB[126 + E + offset];
            Bitplane2_Bottom_Right_ROW[1] = oDataB[124 + E + offset];
            Bitplane2_Bottom_Right_ROW[2] = oDataB[122 + E + offset];
            Bitplane2_Bottom_Right_ROW[3] = oDataB[120 + E + offset];
            Bitplane2_Bottom_Right_ROW[4] = oDataB[118 + E + offset];
            Bitplane2_Bottom_Right_ROW[5] = oDataB[116 + E + offset];
            Bitplane2_Bottom_Right_ROW[6] = oDataB[114 + E + offset];
            Bitplane2_Bottom_Right_ROW[7] = oDataB[112 + E + offset];


            Bitplane3_Bottom_Right_ROW[0] = oDataB[127 + E + offset];
            Bitplane3_Bottom_Right_ROW[1] = oDataB[125 + E + offset];
            Bitplane3_Bottom_Right_ROW[2] = oDataB[123 + E + offset];
            Bitplane3_Bottom_Right_ROW[3] = oDataB[121 + E + offset];
            Bitplane3_Bottom_Right_ROW[4] = oDataB[119 + E + offset];
            Bitplane3_Bottom_Right_ROW[5] = oDataB[117 + E + offset];
            Bitplane3_Bottom_Right_ROW[6] = oDataB[115 + E + offset];
            Bitplane3_Bottom_Right_ROW[7] = oDataB[113 + E + offset];

            E = E + 128 + 10; // the location of the curent sprite. Each sprite is 128 bytes (32 bytes x  4 tiles). The +10 is the size of the header.
        }

        if (X > 34 && X <= 43) // Assign the DK Map Sprites? to the bitplane rows.
        {
           if (X == 35) { E = 0; }
           if (X == 36) { E = E + 128 + 34 + 10; } // This skips a sprite frame that had more then 4 8x8 tiles. I will attempt to export this frame later.


            // Top Left Tile
            Bitplane0_Top_Left_ROW[0] = oDataC[14 + E + offset];
            Bitplane0_Top_Left_ROW[1] = oDataC[12 + E + offset];
            Bitplane0_Top_Left_ROW[2] = oDataC[10 + E + offset];
            Bitplane0_Top_Left_ROW[3] = oDataC[8 + E + offset];
            Bitplane0_Top_Left_ROW[4] = oDataC[6 + E + offset];
            Bitplane0_Top_Left_ROW[5] = oDataC[4 + E + offset];
            Bitplane0_Top_Left_ROW[6] = oDataC[2 + E + offset];
            Bitplane0_Top_Left_ROW[7] = oDataC[0 + E + offset];

            Bitplane1_Top_Left_ROW[0] = oDataC[15 + E + offset];
            Bitplane1_Top_Left_ROW[1] = oDataC[13 + E + offset];
            Bitplane1_Top_Left_ROW[2] = oDataC[11 + E + offset];
            Bitplane1_Top_Left_ROW[3] = oDataC[9 + E + offset];
            Bitplane1_Top_Left_ROW[4] = oDataC[7 + E + offset];
            Bitplane1_Top_Left_ROW[5] = oDataC[5 + E + offset];
            Bitplane1_Top_Left_ROW[6] = oDataC[3 + E + offset];
            Bitplane1_Top_Left_ROW[7] = oDataC[1 + E + offset];

            Bitplane2_Top_Left_ROW[0] = oDataC[30 + E + offset];
            Bitplane2_Top_Left_ROW[1] = oDataC[28 + E + offset];
            Bitplane2_Top_Left_ROW[2] = oDataC[26 + E + offset];
            Bitplane2_Top_Left_ROW[3] = oDataC[24 + E + offset];
            Bitplane2_Top_Left_ROW[4] = oDataC[22 + E + offset];
            Bitplane2_Top_Left_ROW[5] = oDataC[20 + E + offset];
            Bitplane2_Top_Left_ROW[6] = oDataC[18 + E + offset];
            Bitplane2_Top_Left_ROW[7] = oDataC[16 + E + offset];

            Bitplane3_Top_Left_ROW[0] = oDataC[31 + E + offset];
            Bitplane3_Top_Left_ROW[1] = oDataC[29 + E + offset];
            Bitplane3_Top_Left_ROW[2] = oDataC[27 + E + offset];
            Bitplane3_Top_Left_ROW[3] = oDataC[25 + E + offset];
            Bitplane3_Top_Left_ROW[4] = oDataC[23 + E + offset];
            Bitplane3_Top_Left_ROW[5] = oDataC[21 + E + offset];
            Bitplane3_Top_Left_ROW[6] = oDataC[19 + E + offset];
            Bitplane3_Top_Left_ROW[7] = oDataC[17 + E + offset];

            //  Top Right Tile


            Bitplane0_Top_Right_ROW[0] = oDataC[46 + E + offset];
            Bitplane0_Top_Right_ROW[1] = oDataC[44 + E + offset];
            Bitplane0_Top_Right_ROW[2] = oDataC[42 + E + offset];
            Bitplane0_Top_Right_ROW[3] = oDataC[40 + E + offset];
            Bitplane0_Top_Right_ROW[4] = oDataC[38 + E + offset];
            Bitplane0_Top_Right_ROW[5] = oDataC[36 + E + offset];
            Bitplane0_Top_Right_ROW[6] = oDataC[34 + E + offset];
            Bitplane0_Top_Right_ROW[7] = oDataC[32 + E + offset];

            Bitplane1_Top_Right_ROW[0] = oDataC[47 + E + offset];
            Bitplane1_Top_Right_ROW[1] = oDataC[45 + E + offset];
            Bitplane1_Top_Right_ROW[2] = oDataC[43 + E + offset];
            Bitplane1_Top_Right_ROW[3] = oDataC[41 + E + offset];
            Bitplane1_Top_Right_ROW[4] = oDataC[39 + E + offset];
            Bitplane1_Top_Right_ROW[5] = oDataC[37 + E + offset];
            Bitplane1_Top_Right_ROW[6] = oDataC[35 + E + offset];
            Bitplane1_Top_Right_ROW[7] = oDataC[33 + E + offset];

            Bitplane2_Top_Right_ROW[0] = oDataC[62 + E + offset];
            Bitplane2_Top_Right_ROW[1] = oDataC[60 + E + offset];
            Bitplane2_Top_Right_ROW[2] = oDataC[58 + E + offset];
            Bitplane2_Top_Right_ROW[3] = oDataC[56 + E + offset];
            Bitplane2_Top_Right_ROW[4] = oDataC[54 + E + offset];
            Bitplane2_Top_Right_ROW[5] = oDataC[52 + E + offset];
            Bitplane2_Top_Right_ROW[6] = oDataC[50 + E + offset];
            Bitplane2_Top_Right_ROW[7] = oDataC[48 + E + offset];

            Bitplane3_Top_Right_ROW[0] = oDataC[63 + E + offset];
            Bitplane3_Top_Right_ROW[1] = oDataC[61 + E + offset];
            Bitplane3_Top_Right_ROW[2] = oDataC[59 + E + offset];
            Bitplane3_Top_Right_ROW[3] = oDataC[57 + E + offset];
            Bitplane3_Top_Right_ROW[4] = oDataC[55 + E + offset];
            Bitplane3_Top_Right_ROW[5] = oDataC[53 + E + offset];
            Bitplane3_Top_Right_ROW[6] = oDataC[51 + E + offset];
            Bitplane3_Top_Right_ROW[7] = oDataC[49 + E + offset];


            // Letter K -- Bottom Left Tile


            Bitplane0_Bottom_Left_ROW[0] = oDataC[78 + E + offset];
            Bitplane0_Bottom_Left_ROW[1] = oDataC[76 + E + offset];
            Bitplane0_Bottom_Left_ROW[2] = oDataC[74 + E + offset];
            Bitplane0_Bottom_Left_ROW[3] = oDataC[72 + E + offset];
            Bitplane0_Bottom_Left_ROW[4] = oDataC[70 + E + offset];
            Bitplane0_Bottom_Left_ROW[5] = oDataC[68 + E + offset];
            Bitplane0_Bottom_Left_ROW[6] = oDataC[66 + E + offset];
            Bitplane0_Bottom_Left_ROW[7] = oDataC[64 + E + offset];

            Bitplane1_Bottom_Left_ROW[0] = oDataC[79 + E + offset];
            Bitplane1_Bottom_Left_ROW[1] = oDataC[77 + E + offset];
            Bitplane1_Bottom_Left_ROW[2] = oDataC[75 + E + offset];
            Bitplane1_Bottom_Left_ROW[3] = oDataC[73 + E + offset];
            Bitplane1_Bottom_Left_ROW[4] = oDataC[71 + E + offset];
            Bitplane1_Bottom_Left_ROW[5] = oDataC[69 + E + offset];
            Bitplane1_Bottom_Left_ROW[6] = oDataC[67 + E + offset];
            Bitplane1_Bottom_Left_ROW[7] = oDataC[65 + E + offset];

            Bitplane2_Bottom_Left_ROW[0] = oDataC[94 + E + offset];
            Bitplane2_Bottom_Left_ROW[1] = oDataC[92 + E + offset];
            Bitplane2_Bottom_Left_ROW[2] = oDataC[90 + E + offset];
            Bitplane2_Bottom_Left_ROW[3] = oDataC[88 + E + offset];
            Bitplane2_Bottom_Left_ROW[4] = oDataC[86 + E + offset];
            Bitplane2_Bottom_Left_ROW[5] = oDataC[84 + E + offset];
            Bitplane2_Bottom_Left_ROW[6] = oDataC[82 + E + offset];
            Bitplane2_Bottom_Left_ROW[7] = oDataC[80 + E + offset];

            Bitplane3_Bottom_Left_ROW[0] = oDataC[95 + E + offset];
            Bitplane3_Bottom_Left_ROW[1] = oDataC[93 + E + offset];
            Bitplane3_Bottom_Left_ROW[2] = oDataC[91 + E + offset];
            Bitplane3_Bottom_Left_ROW[3] = oDataC[89 + E + offset];
            Bitplane3_Bottom_Left_ROW[4] = oDataC[87 + E + offset];
            Bitplane3_Bottom_Left_ROW[5] = oDataC[85 + E + offset];
            Bitplane3_Bottom_Left_ROW[6] = oDataC[83 + E + offset];
            Bitplane3_Bottom_Left_ROW[7] = oDataC[81 + E + offset];


            // Bottom Right Tile


            Bitplane0_Bottom_Right_ROW[0] = oDataC[110 + E + offset];
            Bitplane0_Bottom_Right_ROW[1] = oDataC[108 + E + offset];
            Bitplane0_Bottom_Right_ROW[2] = oDataC[106 + E + offset];
            Bitplane0_Bottom_Right_ROW[3] = oDataC[104 + E + offset];
            Bitplane0_Bottom_Right_ROW[4] = oDataC[102 + E + offset];
            Bitplane0_Bottom_Right_ROW[5] = oDataC[100 + E + offset];
            Bitplane0_Bottom_Right_ROW[6] = oDataC[98 + E + offset];
            Bitplane0_Bottom_Right_ROW[7] = oDataC[96 + E + offset];

            Bitplane1_Bottom_Right_ROW[0] = oDataC[111 + E + offset];
            Bitplane1_Bottom_Right_ROW[1] = oDataC[109 + E + offset];
            Bitplane1_Bottom_Right_ROW[2] = oDataC[107 + E + offset];
            Bitplane1_Bottom_Right_ROW[3] = oDataC[105 + E + offset];
            Bitplane1_Bottom_Right_ROW[4] = oDataC[103 + E + offset];
            Bitplane1_Bottom_Right_ROW[5] = oDataC[101 + E + offset];
            Bitplane1_Bottom_Right_ROW[6] = oDataC[99 + E + offset];
            Bitplane1_Bottom_Right_ROW[7] = oDataC[97 + E + offset];


            Bitplane2_Bottom_Right_ROW[0] = oDataC[126 + E + offset];
            Bitplane2_Bottom_Right_ROW[1] = oDataC[124 + E + offset];
            Bitplane2_Bottom_Right_ROW[2] = oDataC[122 + E + offset];
            Bitplane2_Bottom_Right_ROW[3] = oDataC[120 + E + offset];
            Bitplane2_Bottom_Right_ROW[4] = oDataC[118 + E + offset];
            Bitplane2_Bottom_Right_ROW[5] = oDataC[116 + E + offset];
            Bitplane2_Bottom_Right_ROW[6] = oDataC[114 + E + offset];
            Bitplane2_Bottom_Right_ROW[7] = oDataC[112 + E + offset];


            Bitplane3_Bottom_Right_ROW[0] = oDataC[127 + E + offset];
            Bitplane3_Bottom_Right_ROW[1] = oDataC[125 + E + offset];
            Bitplane3_Bottom_Right_ROW[2] = oDataC[123 + E + offset];
            Bitplane3_Bottom_Right_ROW[3] = oDataC[121 + E + offset];
            Bitplane3_Bottom_Right_ROW[4] = oDataC[119 + E + offset];
            Bitplane3_Bottom_Right_ROW[5] = oDataC[117 + E + offset];
            Bitplane3_Bottom_Right_ROW[6] = oDataC[115 + E + offset];
            Bitplane3_Bottom_Right_ROW[7] = oDataC[113 + E + offset];

            E = E + 128 + 10; // the location of the curent sprite. Each sprite is 128 bytes (32 bytes x  4 tiles). The +10 is the size of the header.
        }

        if (X > 43 && X <= 60) // Assign the Diddy Map Sprites? to the bitplane rows.
        {
            if (X == 44) { E = 0; }

            // Top Left Tile
            Bitplane0_Top_Left_ROW[0] = oDataD[14 + E + offset];
            Bitplane0_Top_Left_ROW[1] = oDataD[12 + E + offset];
            Bitplane0_Top_Left_ROW[2] = oDataD[10 + E + offset];
            Bitplane0_Top_Left_ROW[3] = oDataD[8 + E + offset];
            Bitplane0_Top_Left_ROW[4] = oDataD[6 + E + offset];
            Bitplane0_Top_Left_ROW[5] = oDataD[4 + E + offset];
            Bitplane0_Top_Left_ROW[6] = oDataD[2 + E + offset];
            Bitplane0_Top_Left_ROW[7] = oDataD[0 + E + offset];

            Bitplane1_Top_Left_ROW[0] = oDataD[15 + E + offset];
            Bitplane1_Top_Left_ROW[1] = oDataD[13 + E + offset];
            Bitplane1_Top_Left_ROW[2] = oDataD[11 + E + offset];
            Bitplane1_Top_Left_ROW[3] = oDataD[9 + E + offset];
            Bitplane1_Top_Left_ROW[4] = oDataD[7 + E + offset];
            Bitplane1_Top_Left_ROW[5] = oDataD[5 + E + offset];
            Bitplane1_Top_Left_ROW[6] = oDataD[3 + E + offset];
            Bitplane1_Top_Left_ROW[7] = oDataD[1 + E + offset];

            Bitplane2_Top_Left_ROW[0] = oDataD[30 + E + offset];
            Bitplane2_Top_Left_ROW[1] = oDataD[28 + E + offset];
            Bitplane2_Top_Left_ROW[2] = oDataD[26 + E + offset];
            Bitplane2_Top_Left_ROW[3] = oDataD[24 + E + offset];
            Bitplane2_Top_Left_ROW[4] = oDataD[22 + E + offset];
            Bitplane2_Top_Left_ROW[5] = oDataD[20 + E + offset];
            Bitplane2_Top_Left_ROW[6] = oDataD[18 + E + offset];
            Bitplane2_Top_Left_ROW[7] = oDataD[16 + E + offset];

            Bitplane3_Top_Left_ROW[0] = oDataD[31 + E + offset];
            Bitplane3_Top_Left_ROW[1] = oDataD[29 + E + offset];
            Bitplane3_Top_Left_ROW[2] = oDataD[27 + E + offset];
            Bitplane3_Top_Left_ROW[3] = oDataD[25 + E + offset];
            Bitplane3_Top_Left_ROW[4] = oDataD[23 + E + offset];
            Bitplane3_Top_Left_ROW[5] = oDataD[21 + E + offset];
            Bitplane3_Top_Left_ROW[6] = oDataD[19 + E + offset];
            Bitplane3_Top_Left_ROW[7] = oDataD[17 + E + offset];

            //  Top Right Tile


            Bitplane0_Top_Right_ROW[0] = oDataD[46 + E + offset];
            Bitplane0_Top_Right_ROW[1] = oDataD[44 + E + offset];
            Bitplane0_Top_Right_ROW[2] = oDataD[42 + E + offset];
            Bitplane0_Top_Right_ROW[3] = oDataD[40 + E + offset];
            Bitplane0_Top_Right_ROW[4] = oDataD[38 + E + offset];
            Bitplane0_Top_Right_ROW[5] = oDataD[36 + E + offset];
            Bitplane0_Top_Right_ROW[6] = oDataD[34 + E + offset];
            Bitplane0_Top_Right_ROW[7] = oDataD[32 + E + offset];

            Bitplane1_Top_Right_ROW[0] = oDataD[47 + E + offset];
            Bitplane1_Top_Right_ROW[1] = oDataD[45 + E + offset];
            Bitplane1_Top_Right_ROW[2] = oDataD[43 + E + offset];
            Bitplane1_Top_Right_ROW[3] = oDataD[41 + E + offset];
            Bitplane1_Top_Right_ROW[4] = oDataD[39 + E + offset];
            Bitplane1_Top_Right_ROW[5] = oDataD[37 + E + offset];
            Bitplane1_Top_Right_ROW[6] = oDataD[35 + E + offset];
            Bitplane1_Top_Right_ROW[7] = oDataD[33 + E + offset];

            Bitplane2_Top_Right_ROW[0] = oDataD[62 + E + offset];
            Bitplane2_Top_Right_ROW[1] = oDataD[60 + E + offset];
            Bitplane2_Top_Right_ROW[2] = oDataD[58 + E + offset];
            Bitplane2_Top_Right_ROW[3] = oDataD[56 + E + offset];
            Bitplane2_Top_Right_ROW[4] = oDataD[54 + E + offset];
            Bitplane2_Top_Right_ROW[5] = oDataD[52 + E + offset];
            Bitplane2_Top_Right_ROW[6] = oDataD[50 + E + offset];
            Bitplane2_Top_Right_ROW[7] = oDataD[48 + E + offset];

            Bitplane3_Top_Right_ROW[0] = oDataD[63 + E + offset];
            Bitplane3_Top_Right_ROW[1] = oDataD[61 + E + offset];
            Bitplane3_Top_Right_ROW[2] = oDataD[59 + E + offset];
            Bitplane3_Top_Right_ROW[3] = oDataD[57 + E + offset];
            Bitplane3_Top_Right_ROW[4] = oDataD[55 + E + offset];
            Bitplane3_Top_Right_ROW[5] = oDataD[53 + E + offset];
            Bitplane3_Top_Right_ROW[6] = oDataD[51 + E + offset];
            Bitplane3_Top_Right_ROW[7] = oDataD[49 + E + offset];


            // Letter K -- Bottom Left Tile


            Bitplane0_Bottom_Left_ROW[0] = oDataD[78 + E + offset];
            Bitplane0_Bottom_Left_ROW[1] = oDataD[76 + E + offset];
            Bitplane0_Bottom_Left_ROW[2] = oDataD[74 + E + offset];
            Bitplane0_Bottom_Left_ROW[3] = oDataD[72 + E + offset];
            Bitplane0_Bottom_Left_ROW[4] = oDataD[70 + E + offset];
            Bitplane0_Bottom_Left_ROW[5] = oDataD[68 + E + offset];
            Bitplane0_Bottom_Left_ROW[6] = oDataD[66 + E + offset];
            Bitplane0_Bottom_Left_ROW[7] = oDataD[64 + E + offset];

            Bitplane1_Bottom_Left_ROW[0] = oDataD[79 + E + offset];
            Bitplane1_Bottom_Left_ROW[1] = oDataD[77 + E + offset];
            Bitplane1_Bottom_Left_ROW[2] = oDataD[75 + E + offset];
            Bitplane1_Bottom_Left_ROW[3] = oDataD[73 + E + offset];
            Bitplane1_Bottom_Left_ROW[4] = oDataD[71 + E + offset];
            Bitplane1_Bottom_Left_ROW[5] = oDataD[69 + E + offset];
            Bitplane1_Bottom_Left_ROW[6] = oDataD[67 + E + offset];
            Bitplane1_Bottom_Left_ROW[7] = oDataD[65 + E + offset];

            Bitplane2_Bottom_Left_ROW[0] = oDataD[94 + E + offset];
            Bitplane2_Bottom_Left_ROW[1] = oDataD[92 + E + offset];
            Bitplane2_Bottom_Left_ROW[2] = oDataD[90 + E + offset];
            Bitplane2_Bottom_Left_ROW[3] = oDataD[88 + E + offset];
            Bitplane2_Bottom_Left_ROW[4] = oDataD[86 + E + offset];
            Bitplane2_Bottom_Left_ROW[5] = oDataD[84 + E + offset];
            Bitplane2_Bottom_Left_ROW[6] = oDataD[82 + E + offset];
            Bitplane2_Bottom_Left_ROW[7] = oDataD[80 + E + offset];

            Bitplane3_Bottom_Left_ROW[0] = oDataD[95 + E + offset];
            Bitplane3_Bottom_Left_ROW[1] = oDataD[93 + E + offset];
            Bitplane3_Bottom_Left_ROW[2] = oDataD[91 + E + offset];
            Bitplane3_Bottom_Left_ROW[3] = oDataD[89 + E + offset];
            Bitplane3_Bottom_Left_ROW[4] = oDataD[87 + E + offset];
            Bitplane3_Bottom_Left_ROW[5] = oDataD[85 + E + offset];
            Bitplane3_Bottom_Left_ROW[6] = oDataD[83 + E + offset];
            Bitplane3_Bottom_Left_ROW[7] = oDataD[81 + E + offset];


            // Bottom Right Tile


            Bitplane0_Bottom_Right_ROW[0] = oDataD[110 + E + offset];
            Bitplane0_Bottom_Right_ROW[1] = oDataD[108 + E + offset];
            Bitplane0_Bottom_Right_ROW[2] = oDataD[106 + E + offset];
            Bitplane0_Bottom_Right_ROW[3] = oDataD[104 + E + offset];
            Bitplane0_Bottom_Right_ROW[4] = oDataD[102 + E + offset];
            Bitplane0_Bottom_Right_ROW[5] = oDataD[100 + E + offset];
            Bitplane0_Bottom_Right_ROW[6] = oDataD[98 + E + offset];
            Bitplane0_Bottom_Right_ROW[7] = oDataD[96 + E + offset];

            Bitplane1_Bottom_Right_ROW[0] = oDataD[111 + E + offset];
            Bitplane1_Bottom_Right_ROW[1] = oDataD[109 + E + offset];
            Bitplane1_Bottom_Right_ROW[2] = oDataD[107 + E + offset];
            Bitplane1_Bottom_Right_ROW[3] = oDataD[105 + E + offset];
            Bitplane1_Bottom_Right_ROW[4] = oDataD[103 + E + offset];
            Bitplane1_Bottom_Right_ROW[5] = oDataD[101 + E + offset];
            Bitplane1_Bottom_Right_ROW[6] = oDataD[99 + E + offset];
            Bitplane1_Bottom_Right_ROW[7] = oDataD[97 + E + offset];


            Bitplane2_Bottom_Right_ROW[0] = oDataD[126 + E + offset];
            Bitplane2_Bottom_Right_ROW[1] = oDataD[124 + E + offset];
            Bitplane2_Bottom_Right_ROW[2] = oDataD[122 + E + offset];
            Bitplane2_Bottom_Right_ROW[3] = oDataD[120 + E + offset];
            Bitplane2_Bottom_Right_ROW[4] = oDataD[118 + E + offset];
            Bitplane2_Bottom_Right_ROW[5] = oDataD[116 + E + offset];
            Bitplane2_Bottom_Right_ROW[6] = oDataD[114 + E + offset];
            Bitplane2_Bottom_Right_ROW[7] = oDataD[112 + E + offset];


            Bitplane3_Bottom_Right_ROW[0] = oDataD[127 + E + offset];
            Bitplane3_Bottom_Right_ROW[1] = oDataD[125 + E + offset];
            Bitplane3_Bottom_Right_ROW[2] = oDataD[123 + E + offset];
            Bitplane3_Bottom_Right_ROW[3] = oDataD[121 + E + offset];
            Bitplane3_Bottom_Right_ROW[4] = oDataD[119 + E + offset];
            Bitplane3_Bottom_Right_ROW[5] = oDataD[117 + E + offset];
            Bitplane3_Bottom_Right_ROW[6] = oDataD[115 + E + offset];
            Bitplane3_Bottom_Right_ROW[7] = oDataD[113 + E + offset];

            E = E + 128 + 10; // the location of the curent sprite. Each sprite is 128 bytes (32 bytes x  4 tiles). The +10 is the size of the header.
        }




























        // Check which bits are set for each pixel of the tiles. Then assign the index colour to the image Array location.
        int c = 0;
        
        for (int p = 0; p < 8; p++) // Bottom Left Tile
        {
            if (p == 7) { c = 512; }
            if (p == 6) { c = 576; }
            if (p == 5) { c = 640; }
            if (p == 4) { c = 704; }
            if (p == 3) { c = 768; }
            if (p == 2) { c = 832; }
            if (p == 1) { c = 896; }
            if (p == 0) { c = 960; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Bottom_Left_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Bottom_Left_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();



                if (X < 35) // Asign the colours using the Kong Letters and Banana Sprites Palette 
                {
                    image[c++] = colours[Index][0]; // Red
                    image[c++] = colours[Index][1]; // Green
                    image[c++] = colours[Index][2]; // Blue 
                    image[c++] = colours[Index][3]; // Alpha
                }
                else if (X > 33 && X <= 43) // Asign the colours using the Donkey Kong Palette 
                {
                    image[c++] = coloursB[Index][0]; // Red
                    image[c++] = coloursB[Index][1]; // Green
                    image[c++] = coloursB[Index][2]; // Blue 
                    image[c++] = coloursB[Index][3]; // Alpha
                }
                else if (X > 43 && X <= 60) // Asign the colours using the Diddy Kong Palette  
                {
                    image[c++] = coloursC[Index][0]; // Red
                    image[c++] = coloursC[Index][1]; // Green
                    image[c++] = coloursC[Index][2]; // Blue 
                    image[c++] = coloursC[Index][3]; // Alpha
                }

            }

        }

        for (int p = 0; p < 8; p++) // Top Left Tile
        {
            if (p == 7) { c = 0; }
            if (p == 6) { c = 64; }
            if (p == 5) { c = 128; }
            if (p == 4) { c = 192; }
            if (p == 3) { c = 256; }
            if (p == 2) { c = 320; }
            if (p == 1) { c = 384; }
            if (p == 0) { c = 448; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Top_Left_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Top_Left_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Top_Left_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Top_Left_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();

                if (X < 35) // Asign the colours using the Kong Letters and Banana Sprites Palette
                {
                    image[c++] = colours[Index][0]; // Red
                    image[c++] = colours[Index][1]; // Green
                    image[c++] = colours[Index][2]; // Blue 
                    image[c++] = colours[Index][3]; // Alpha
                }
                else if (X > 33 && X <= 43) // Asign the colours using the Donkey Kong Palette
                {
                    image[c++] = coloursB[Index][0]; // Red
                    image[c++] = coloursB[Index][1]; // Green
                    image[c++] = coloursB[Index][2]; // Blue 
                    image[c++] = coloursB[Index][3]; // Alpha
                }
                else if (X > 43 && X <= 60) // Asign the colours using the Diddy Kong Palette 
                {
                    image[c++] = coloursC[Index][0]; // Red
                    image[c++] = coloursC[Index][1]; // Green
                    image[c++] = coloursC[Index][2]; // Blue 
                    image[c++] = coloursC[Index][3]; // Alpha
                }
            }
        }
        
        for (int p = 0; p < 8; p++) // bottom Right Tile.
        {
            if (p == 7) { c = 512 +32; }
            if (p == 6) { c = 576 + 32; }
            if (p == 5) { c = 640 + 32; }
            if (p == 4) { c = 704 + 32; }
            if (p == 3) { c = 768 + 32; }
            if (p == 2) { c = 832 + 32; }
            if (p == 1) { c = 896 + 32; }
            if (p == 0) { c = 960 + 32; }

           

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Bottom_Right_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Bottom_Right_ROW[p] >> N) & 1);
                unsigned long long Index = bs.to_ulong();


                if (X < 35) // Asign the colours using the Kong Letters and Banana Sprites Palette
                {
                    image[c++] = colours[Index][0]; // Red
                    image[c++] = colours[Index][1]; // Green
                    image[c++] = colours[Index][2]; // Blue 
                    image[c++] = colours[Index][3]; // Alpha
                }
                else if (X > 33 && X <= 43) // Asign the colours using the Donkey Kong Palette
                {
                    image[c++] = coloursB[Index][0]; // Red
                    image[c++] = coloursB[Index][1]; // Green
                    image[c++] = coloursB[Index][2]; // Blue 
                    image[c++] = coloursB[Index][3]; // Alpha
                }
                else if (X > 43 && X <= 60) // Asign the colours using the Diddy Kong Palette 
                {
                    image[c++] = coloursC[Index][0]; // Red
                    image[c++] = coloursC[Index][1]; // Green
                    image[c++] = coloursC[Index][2]; // Blue 
                    image[c++] = coloursC[Index][3]; // Alpha
                }
            }

        }

        
        for (int p = 0; p < 8; p++) // top Right Tile.
        {
            if (p == 7) { c = 32; }
            if (p == 6) { c = 96; }
            if (p == 5) { c = 160; }
            if (p == 4) { c = 224; }
            if (p == 3) { c = 288; }
            if (p == 2) { c = 352; }
            if (p == 1) { c = 416; }
            if (p == 0) { c = 480; }

            for (int j = 0, N = 7; j < 8; j++, N--)
            {
                std::bitset<4> bs;
                bs.set(0, (Bitplane0_Top_Right_ROW[p] >> N) & 1);
                bs.set(1, (Bitplane1_Top_Right_ROW[p] >> N) & 1);
                bs.set(2, (Bitplane2_Top_Right_ROW[p] >> N) & 1);
                bs.set(3, (Bitplane3_Top_Right_ROW[p] >> N) & 1);
                unsigned long Index = bs.to_ulong();

                if (X < 35) // Asign the colours using the Kong Letters and Banana Sprites Palette
                {
                    image[c++] = colours[Index][0]; // Red
                    image[c++] = colours[Index][1]; // Green
                    image[c++] = colours[Index][2]; // Blue 
                    image[c++] = colours[Index][3]; // Alpha
                }
                else if (X > 33 && X <= 43) // Asign the colours using the Donkey Kong Palette
                {
                    image[c++] = coloursB[Index][0]; // Red
                    image[c++] = coloursB[Index][1]; // Green
                    image[c++] = coloursB[Index][2]; // Blue 
                    image[c++] = coloursB[Index][3]; // Alpha
                }
                else if (X > 43 && X <= 60) // Asign the colours using the Diddy Kong Palette 
                {
                    image[c++] = coloursC[Index][0]; // Red
                    image[c++] = coloursC[Index][1]; // Green
                    image[c++] = coloursC[Index][2]; // Blue 
                    image[c++] = coloursC[Index][3]; // Alpha
                }
            }
        }
        
        if (X <= 80)
        {
            string combined_file_path(string(filepath) + to_string(X) + ".png");
            encodeOneStep(combined_file_path.c_str(), image, width, height);  // Write the .png image file.
        }
    }

    return 0;

}


